
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   22:06:36 01/03/2007
-- Design Name:   ddr_w_queue
-- Module Name:   C:/iseproj/dccv2c0a/ddr_w_queue_tb.vhd
-- Project Name:  dccv2c0a
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ddr_w_queue
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY ddr_w_queue_tb_vhd IS
END ddr_w_queue_tb_vhd;

ARCHITECTURE behavior OF ddr_w_queue_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT ddr_w_queue
	PORT(
		reset : IN std_logic;
		clk : IN std_logic;
		mem_test : IN std_logic;
		w_addr : IN std_logic_vector(11 downto 0);
		event_avl : IN std_logic;
		lrb1_avl : IN std_logic;
		lrb2_avl : IN std_logic;
		event_we : IN std_logic;
		lrb1_we : IN std_logic;
		lrb2_we : IN std_logic;
		lrb_data : IN std_logic_vector(33 downto 0);
		event_data : IN std_logic_vector(33 downto 0);
		ddr_w_gnt : IN std_logic;
		w_data : IN std_logic_vector(31 downto 0);
		rd_debug : IN std_logic;
		addr : IN std_logic_vector(13 downto 0);
		run : IN std_logic;
		is_high : IN std_logic;
		n_strobe : IN std_logic;
		pci3_cycle : IN std_logic;
		wr_ddr_data : IN std_logic;
		ddr_pa : IN std_logic_vector(6 downto 0);          
		event_re : OUT std_logic;
		lrb1_re : OUT std_logic;
		lrb2_re : OUT std_logic;
		src_sel : OUT std_logic_vector(1 downto 0);
		ddr_w_dav : OUT std_logic;
		ddr_w_req : OUT std_logic;
		ddr_w_length : OUT std_logic_vector(5 downto 0);
		ddr_w_addr : OUT std_logic_vector(20 downto 0);
		ddr_w_data : OUT std_logic_vector(31 downto 0);
		r_data : OUT std_logic_vector(31 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset :  std_logic := '1';
	SIGNAL clk :  std_logic := '0';
	SIGNAL mem_test :  std_logic := '0';
	SIGNAL event_avl :  std_logic := '0';
	SIGNAL lrb1_avl :  std_logic := '0';
	SIGNAL lrb2_avl :  std_logic := '0';
	SIGNAL event_we :  std_logic := '0';
	SIGNAL lrb1_we :  std_logic := '0';
	SIGNAL lrb2_we :  std_logic := '0';
	SIGNAL ddr_w_gnt :  std_logic := '0';
	SIGNAL rd_debug :  std_logic := '0';
	SIGNAL run :  std_logic := '0';
	SIGNAL is_high :  std_logic := '0';
	SIGNAL n_strobe :  std_logic := '0';
	SIGNAL pci3_cycle :  std_logic := '0';
	SIGNAL wr_ddr_data :  std_logic := '0';
	SIGNAL w_addr :  std_logic_vector(11 downto 0) := (others=>'0');
	SIGNAL lrb_data :  std_logic_vector(33 downto 0) := (others=>'0');
	SIGNAL event_data :  std_logic_vector(33 downto 0) := (others=>'0');
	SIGNAL w_data :  std_logic_vector(31 downto 0) := (others=>'0');
	SIGNAL addr :  std_logic_vector(13 downto 0) := "00000000000001";
	SIGNAL ddr_pa :  std_logic_vector(6 downto 0) := (others=>'0');

	--Outputs
	SIGNAL event_re :  std_logic;
	SIGNAL lrb1_re :  std_logic;
	SIGNAL lrb2_re :  std_logic;
	SIGNAL src_sel :  std_logic_vector(1 downto 0);
	SIGNAL ddr_w_dav :  std_logic;
	SIGNAL ddr_w_req :  std_logic;
	SIGNAL ddr_w_length :  std_logic_vector(5 downto 0);
	SIGNAL ddr_w_addr :  std_logic_vector(20 downto 0);
	SIGNAL ddr_w_data :  std_logic_vector(31 downto 0);
	SIGNAL r_data :  std_logic_vector(31 downto 0);
	constant clk_period : time := 7.8 ns;
	SIGNAL cnt :  std_logic_vector(15 downto 0) := (others=>'0');
	SIGNAL ec_ar :  std_logic;

BEGIN
	-- Instantiate the Unit Under Test (UUT)
	uut: ddr_w_queue PORT MAP(
		reset => reset,
		clk => clk,
		mem_test => mem_test,
		w_addr => w_addr,
		event_avl => event_avl,
		lrb1_avl => lrb1_avl,
		lrb2_avl => lrb2_avl,
		event_we => event_we,
		lrb1_we => lrb1_we,
		lrb2_we => lrb2_we,
		event_re => event_re,
		lrb1_re => lrb1_re,
		lrb2_re => lrb2_re,
		src_sel => src_sel,
		lrb_data => lrb_data,
		event_data => event_data,
		ddr_w_gnt => ddr_w_gnt,
		ddr_w_dav => ddr_w_dav,
		ddr_w_req => ddr_w_req,
		ddr_w_length => ddr_w_length,
		ddr_w_addr => ddr_w_addr,
		ddr_w_data => ddr_w_data,
		w_data => w_data,
		rd_debug => rd_debug,
		r_data => r_data,
		addr => addr,
		run => run,
		is_high => is_high,
		n_strobe => n_strobe,
		pci3_cycle => pci3_cycle,
		wr_ddr_data => wr_ddr_data,
		ddr_pa => ddr_pa
	);
   clk <= not clk after clk_period/2;
	process(clk)
	begin
	  if(clk'event and clk = '1')then
	    n_strobe <= not n_strobe;
		 if(n_strobe = '0')then
	      if((cnt > x"0003" and cnt < x"0007") or(cnt > x"0013" and cnt < x"0016"))then
	        pci3_cycle <= '1';
	      else
	        pci3_cycle <= '0';
	      end if;
			if(is_high = '1')then
			  ec_ar <= '1';
			else
			  ec_ar <= '0';
			end if;
			if(ec_ar = '1')then
			  addr <= addr + 1;
			end if;
	      if((cnt > x"0005" and cnt < x"0008") or cnt = x"0016" or cnt = x"0017")then
	        is_high <= not is_high;
	        wr_ddr_data <= '1';
	      else
			  is_high <= '0';
	        wr_ddr_data <= '0';
	      end if;
	      if(cnt > x"0005" and cnt < x"0018")then
			  w_data <= x"1234" & cnt;
	      else
			  w_data <= x"00000000";
	      end if;
	      if(cnt = x"0011" or cnt = x"001c")then
	        ddr_w_gnt <= '1';
	      else
	        ddr_w_gnt <= '0';
	      end if;
	      cnt <= cnt + 1;
	      if(cnt = x"0004")then
	        reset <= '0';
	      end if;
		 end if;
	    if(cnt > x"389a" and cnt < x"389f")then
--			ddr_wfifo_we <= not n_strobe;
	    else
--		 	ddr_wfifo_we <= '0';
	    end if;
	    if(cnt = x"389e" and n_strobe = '0')then
--			ddr_w_req <= '1';
	    else
--		 	ddr_w_req <= '0';
	    end if;
	  end if;
	end process;

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
